{ V1.0 for D7
  TSimpleUI ,ִ߳ TObjectProc
  by 2013(QQ:26562729) 2018.05.02
}
unit uSimpleUI;
interface
uses
  Classes, uSimpleThread, uSimpleList;
type

  // Ϊ D7 ûܡҪ Pointer ݲ

  TRunningInMainProc = procedure(Param: Pointer) of object; // ߳е Proc
  TReleaseParamProc = procedure(Param: Pointer) of object; // ͷ Param  proc

  TRimList = class;

  //  TSimpleThread, TSimpleList

  TSimpleUI = class(TSimpleThread)
  private
    FRmtpList: TRimList;
    procedure DoWork;
    procedure Work;
  public
    constructor Create; reintroduce;
    destructor Destroy; override;
    // ARmpProc proc߳ȥִ
    // ARppProc Ϊ nil ,ҪԼͷ Param;
    class procedure ExeProcInMainThread(AParam: Pointer; ARmpProc: TRunningInMainProc; ARppProc: TReleaseParamProc = nil);
  end;

  TRimObject = class
  private
    Param: Pointer;
    RunningInMainProc: TRunningInMainProc;
    ReleaseParamProc: TReleaseParamProc;
    procedure DoExeProcInMainThread;
  public
    destructor Destroy; override;
  end;

  TRimList = class(TSimpleList)
  protected
    procedure FreeItem(Item: Pointer); override;
  end;

implementation
var
  RmtpThread: TSimpleUI;

{ TRimList }

procedure TRimList.FreeItem(Item: Pointer);
begin
  TRimObject(Item).free;
end;

{ TSimpleUI }

constructor TSimpleUI.Create;
begin
  inherited Create(false);
  FRmtpList := TRimList.Create;
end;

destructor TSimpleUI.Destroy;
begin
  FRmtpList.free;
  inherited;
end;

procedure TSimpleUI.DoWork;
var
  Q: TRimObject;
begin

  FRmtpList.Lock;
  try
    Q := FRmtpList.PopFirst;
  finally
    FRmtpList.Unlock;
  end;

  if Assigned(Q) then
  begin
    TThread.Synchronize(nil, Q.DoExeProcInMainThread);
    Q.free;
    Work;
  end;

end;

class procedure TSimpleUI.ExeProcInMainThread(AParam: Pointer; ARmpProc: TRunningInMainProc; ARppProc: TReleaseParamProc);
var
  Q: TRimObject;
  L: TRimList;
begin
  L := RmtpThread.FRmtpList;
  L.Lock;
  try
    Q := TRimObject.Create;
    Q.Param := AParam;
    Q.RunningInMainProc := ARmpProc;
    Q.ReleaseParamProc := ARppProc;
    L.Add(Q);
    RmtpThread.Work; // ߳
  finally
    L.Unlock;
  end;
end;

procedure TSimpleUI.Work;
begin
  ExeProcInThread(DoWork);
end;

{ TRimObject }

destructor TRimObject.Destroy;
begin
  if Assigned(ReleaseParamProc) then
    ReleaseParamProc(Param);
  inherited;
end;

procedure TRimObject.DoExeProcInMainThread;
begin
  if Assigned(RunningInMainProc) then
    RunningInMainProc(Param);
end;

initialization
  RmtpThread := TSimpleUI.Create;

finalization
  RmtpThread.free;

end.

