
unit uSumThread;
interface
uses
  uSimpleThread;

type
  TSumThread = class;

  TSumStatus = (ssOK, ssErr, ssStop);

  TOnSumStatus = procedure(Sender: TSumThread; AStatus: TSumStatus) of object;

  //  1 ӵ  N Ĺ
  // TSimpleThread Ӧ

  TSumThread = class(TSimpleThread)
  private
    procedure Sum;
    procedure DoSum;
    procedure DoOnSumStatus(AStatus: TSumStatus);
  public
    Num: integer;
    TotalSum: integer;
    OnSumStatus: TOnSumStatus;
    procedure StartThread; override;
  end;

implementation

{ TSumThread }

procedure TSumThread.DoOnSumStatus(AStatus: TSumStatus);
begin
  if Assigned(OnSumStatus) then OnSumStatus(self, AStatus);
end;

procedure TSumThread.DoSum;
var
  i: integer;
begin
  TotalSum := 0;

  if Num <= 0 then
  begin
    DoOnSumStatus(ssErr);
    Exit;
  end;

  for i := 1 to Num do
  begin
    inc(TotalSum, i);
    SleepExceptStopped(5); // 㣬Ч

    if FWaitStop then // ִ߳йУӦ˳ָ
    begin
      DoOnSumStatus(ssStop);
      Exit;
    end;

  end;

  DoOnSumStatus(ssOK);

end;

procedure TSumThread.StartThread;
begin
  inherited;
  Sum;
end;

procedure TSumThread.Sum;
begin
  ExeProcInThread(DoSum);
end;

end.

