unit uTestMgt;

interface
uses

  uSimpleUI, uManagementBase, uSumThread, StdCtrls;

type

  PBtnStatusRec = ^TBtnStatusRec; // Ϊ˴ Button ״̬
  TBtnStatusRec = record
    Btn: TButton;
    Enable: boolean;
  end;

  TOnBtnStatus = procedure(Btn: TButton; AEnable: boolean) of object;


  TTestMgt = class(TManagementBase)
  private
    FSumThread: TSumThread;
    procedure SumStatusEvent(Sender: TSumThread; AStatus: TSumStatus);
  private
    procedure RimEnableBtn(Param: Pointer);
  public
    constructor Create;
    destructor Destroy; override;
    procedure StartWork; override;
  public
    Num: integer;
    BtnSum: TButton;
    OnBtnStatus: TOnBtnStatus;
  end;

implementation

{ TTestMgt }
uses
  SysUtils;

constructor TTestMgt.Create;
begin
  inherited;
  FSumThread := TSumThread.Create;
  FSumThread.OnStatusMsg := self.ThreadDispMsg;
  FSumThread.OnDebugMsg := self.ThreadDispMsg;
  FSumThread.OnSumStatus := self.SumStatusEvent;
end;

destructor TTestMgt.Destroy;
begin
  FSumThread.free;
  inherited;
end;

procedure TTestMgt.RimEnableBtn(Param: Pointer);
var
  P: PBtnStatusRec;
begin
  P := Param;
  if Assigned(OnBtnStatus) then OnBtnStatus(P.Btn, P.Enable);
end;

procedure TTestMgt.StartWork;
begin
  inherited;
  FSumThread.Num := self.Num;
  FSumThread.StartThread;
end;

procedure TTestMgt.SumStatusEvent(Sender: TSumThread; AStatus: TSumStatus);
var
  P: PBtnStatusRec;
begin

  if AStatus = ssOK then
  begin
    DispMsg('Sum:' + IntToStr(Sender.TotalSum));
  end
  else if AStatus = ssErr then
  begin
    DispMsg('Err');
  end
  else
  begin
    DispMsg('Stop');
  end;

  New(P);
  P.Btn := self.BtnSum;
  P.Enable := true;
  // ̵߳ Btn ״̬
  TSimpleUI.ExeProcInMainThread(P, RimEnableBtn);

end;

end.

